# download python interpreter:
# * http://www.enthought.com/products/edudownload.php
#
# useful references: 
# * http://docs.python.org/tutorial
# * http://www.scipy.org/Numpy_Example_List_With_Doc
# * http://matplotlib.sourceforge.net/examples/index.html

import numpy as np
import matplotlib as mpl
import pylab as pl
import random as rand

def secant(input_vector): 
    output_vector = [input_vector[i+1] - input_vector[i] for i in range(0,len(input_vector)-1)]
    return output_vector
    
N=1000

x=np.arange(start=0,stop=N,step=1)
y=np.arange(start=0,stop=2*N,step=2)
difference=np.subtract(x,y)

randomnumbers=[]
for t in range(0,N):
    randomnumbers.append(rand.random())

pl.figure(1)
pl.subplot(311)
pl.plot(difference[100:])
pl.xlabel("i")
pl.ylabel("d(i)")

pl.subplot(312)
pl.plot(secant(difference[100:]))
pl.xlabel("i")
pl.ylabel("d'(i)")

pl.subplot(313)
mpl.pyplot.hist(randomnumbers,bins=100, normed=True)
pl.xlabel("x")
pl.ylabel("P(x)")
pl.show()
